//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  clrDimGray  
#property indicator_color2  clrDeepSkyBlue
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrSandyBrown
#property indicator_color5  clrSandyBrown
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame      = PERIOD_CURRENT; // Time frame to use
extern int                AlmaPeriod     = 14;             // Alma calculation length
extern ENUM_APPLIED_PRICE AlmaPrice      = PRICE_CLOSE;    // Price to use
extern double             AlmaSigma      = 6.0;            // Alma sigma
extern double             AlmaSample     = 0.25;           // Alma sample
extern bool               Interpolate    = true;           // Interpolate in multi time frame mode?

//
//
//
//
//

double alma[];
double almaua[];
double almaub[];
double almada[];
double almadb[];
double prices[];
double parm[];
double trend[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,alma);
   SetIndexBuffer(1,almaua);
   SetIndexBuffer(2,almaub);
   SetIndexBuffer(3,almada);
   SetIndexBuffer(4,almadb);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,prices);
   SetIndexBuffer(7,parm);

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);

   IndicatorShortName(timeFrameToString(TimeFrame)+" Alma ("+(string)AlmaPeriod+")");
   return(0);
}

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { alma[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == _Period)
   {
      if (trend[limit]== 1) CleanPoint(limit,almaua,almaub);
      if (trend[limit]==-1) CleanPoint(limit,almada,almadb);
      for(int i = limit; i >= 0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,AlmaPrice,i);
         
         //
         //
         //
         //
         //
         
         double noise = 0, vhf = 0;
         double max   = prices[i];
         double min   = prices[i];
         for (int k=0; k<AlmaPeriod && (i+k+1)<Bars; k++)
         {
               noise += MathAbs(prices[i+k]-prices[i+k+1]);
               max    = MathMax(prices[i+k],max);   
               min    = MathMin(prices[i+k],min);   
         }      
         if (noise>0) vhf = (max-min)/noise;
         parm[i] = AlmaSigma; if (vhf>0) parm[i] = -MathLog(vhf)*AlmaSigma;
         double tpar = parm[i]; if (i<Bars-5) tpar=(parm[i]+2.0*parm[i+1]+3.0*parm[i+2]+2.0*parm[i+3]+parm[i+4])/9.0;

         //
         //
         //
         //
         //
               
         alma[i]   = iAlma(prices[i],AlmaPeriod,tpar,AlmaSample,i,0);
         almaua[i] = EMPTY_VALUE;
         almaub[i] = EMPTY_VALUE;
         almada[i] = EMPTY_VALUE;
         almadb[i] = EMPTY_VALUE;
         if (i>=Bars-1) continue;
            trend[i] = trend[i+1];
            if (alma[i]>alma[i+1]) trend[i] =  1;
            if (alma[i]<alma[i+1]) trend[i] = -1;
            if (trend[i]== 1) PlotPoint(i,almaua,almaub,alma);
            if (trend[i]==-1) PlotPoint(i,almada,almadb,alma);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
   if (trend[limit]== 1) CleanPoint(limit,almaua,almaub);
   if (trend[limit]==-1) CleanPoint(limit,almada,almadb);
   for (int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         alma[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AlmaPeriod,AlmaPrice,AlmaSigma,AlmaSample,0,y);
         trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AlmaPeriod,AlmaPrice,AlmaSigma,AlmaSample,5,y);
         almaua[i] = EMPTY_VALUE;
         almaub[i] = EMPTY_VALUE;
         almada[i] = EMPTY_VALUE;
         almadb[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         int n,k; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; i+n<Bars && i+k<Bars && k<n; k++)
               alma[i+k] = alma[i] + (alma[i+n]-alma[i])*k/n;
   }
   for (int i=limit;i>=0;i--)
   {
      if (trend[i]== 1) PlotPoint(i,almaua,almaub,alma);
      if (trend[i]==-1) PlotPoint(i,almada,almadb,alma);
   }
   return(0);
}



//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define almaInstances 1
double  almaWork[][almaInstances];
double iAlma(double price, int period, double sigma, double sample, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(almaWork,0)!=Bars) ArrayResize(almaWork,Bars); r = Bars-r-1; almaWork[r][instanceNo] = price;
   
   //
   //
   //
   //
   //

   double m = MathFloor(sample * (period - 1.0));
   double s = period/sigma, sum=0, div=0;
   for (int i=0; i<period && (r-i)>=0; i++)
      {
         double coeff = MathExp(-((i-m)*(i-m))/(2.0*s*s));
            sum += coeff*almaWork[r-i][instanceNo];
            div += coeff;
      }
   double talma = price; if (div!=0) talma = sum/div;
   return(talma);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}